package com.dragon.fuck.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.dragon.fuck.domain.EmsUser;
import com.dragon.fuck.service.EmsUserService;
import com.dragon.fuck.util.Result;
import jakarta.annotation.Resource;
import org.springframework.web.bind.annotation.*;


import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.List;

import static com.dragon.fuck.util.Result.success;

/**
 * 用户表(EmsUser)表控制层
 *
 * @author fengkai
 * @since 2024-01-02 20:35:43
 */
@RestController
@RequestMapping("emsUser")
public class EmsUserController  {
    /**
     * 服务对象
     */
    @Resource
    private EmsUserService emsUserService;

    /**
     * 分页查询所有数据
     *
     * @param page    分页对象
     * @param emsUser 查询实体
     * @return 所有数据
     */
    @GetMapping
    public Result selectAll(Page<EmsUser> page, EmsUser emsUser) {
        return success(this.emsUserService.page(new Page<>(page.getCurrent(),page.getSize()), new QueryWrapper<>(emsUser)));
    }

        @GetMapping("/byName")
        public Result selectByName(@RequestParam("name") String name) {
            try {
                String decodedName = URLDecoder.decode(name, "UTF-8");
                return success(this.emsUserService.selectByName(name));
            } catch (UnsupportedEncodingException e) {
                throw new RuntimeException(e);
            }

        }

    /**
     * 通过主键查询单条数据
     *
     * @param id 主键
     * @return 单条数据
     */
    @GetMapping("{id}")
    public Result selectOne(@PathVariable Serializable id) {
        return success(this.emsUserService.getById(id));
    }

    /**
     * 新增数据
     *
     * @param emsUser 实体对象
     * @return 新增结果
     */
    @PostMapping
    public Result insert(@RequestBody EmsUser emsUser) {
        return success(this.emsUserService.insert(emsUser));
    }

    /**
     * 修改数据
     *
     * @param emsUser 实体对象
     * @return 修改结果
     */
    @PutMapping
    public Result update(@RequestBody EmsUser emsUser) {
        return success(this.emsUserService.updateById(emsUser));
    }

    /**
     * 删除数据
     *
     * @param idList 主键结合
     * @return 删除结果
     */
    @DeleteMapping
    public Result delete(@RequestParam("idList") List<Long> idList) {
        return success(this.emsUserService.removeByIds(idList));
    }
}

