package com.dragon.fuck.util;

import com.dragon.fuck.exception.ServiceException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * @author 冯凯
 * @version 1.0
 * @description: 异常处理类
 * @date 2024/1/2 22:50
 */
@RestControllerAdvice
public class MyExceptionHandler {

    private static final Logger log = LoggerFactory.getLogger(MyExceptionHandler.class);

    @ExceptionHandler(ServiceException.class)
    public Result handleServiceException(ServiceException e) {
        log.error(e.getMessage(), e);
        Integer code = e.getCode();
        return code != null ? Result.error(code, e.getMessage()) : Result.error(e.getMessage());
    }

    @ExceptionHandler(IllegalStateException.class)
    public Result handleServiceException(IllegalStateException e) {
        log.error(e.getMessage(), e);
        return Result.error(e.getMessage());
    }
}
